//**************************************************************************
//
//
//                       National Institute Of Standards and Technology
//                                    DTS Version 1.1
//         
//                              HTMLHtmlElement Interface
//**************************************************************************

function HTMLHtmlElement()
{
   var tests = new Array (HTML0001HHTE());
   return tests;
}

//------------------------ test case HTML-0001HHTE -------------------------
//
// Testing feature - The "version" attribute specifies version information 
//                   about the document's DTD.
//
// Testing approach - Retrieve the "version" attribute from the HTML 
//                    element of the testing document and examine its
//                    value. It should be equal to "TRANSITIONAL 4.0".
//
// Semantic Requirements: 1
//
// Last modification date - November 1, 1999
//
// Written by: Carmelo Montanez
//----------------------------------------------------------------------------

 function HTML0001HHTE()
 {
   var computedValue = "";
   var expectedValue = "TRANSITIONAL 4.0";
   var results = "";
   var testNode = "";

    results = new testResults("HTML0001HHTE");
    results.description = "The \"version\" attribute specifies version "+
                          "information about the document's DTD.";
//
// Retrieve targeted data.
//
      testNode = new HTMLNodeObject(HTML);
//
// and access its "version" attribute.
//
      computedValue = testNode.node.version;
      computedValue = computedValue.toUpperCase();
//
// Write out results 
//
      results.expected = expectedValue;
      results.actual = computedValue;

    return results;
}

//------------------------ End test case HTML-0001HHTE -------------------------
